#ifndef _XewAnimationP_h
#define _XewAnimationP_h
/*
** Copyright 1992 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <X11/Xew/BasicP.h>
#include <X11/Xew/Animation.h>

typedef struct _XeAnimationClass
    {
	int makes_compiler_happy;	/* not used */
    } XeAnimationClassPart;

typedef struct _XeAnimationClassRec
    {
	CoreClassPart core_class;
	XeBasicClassPart basic_class;
	XeAnimationClassPart animation_class;
    } XeAnimationClassRec;

typedef struct
    {
	/* resources */
	unsigned long	first_frame, last_frame, current_frame;
	XePlay		play;
	long		rate;
	Boolean		loop;

	/* private state */
    } XeAnimationPart;

typedef struct _XeAnimationRec
    {
	CorePart	core;
	XeBasicPart	basic;
	XeAnimationPart	animation;
    } XeAnimationRec;

/* Class pointer */
extern XeAnimationClassRec xeAnimationClassRec;

#endif



