#ifndef _XewRaster_h
#define _XewRaster_h
/*
** Copyright 1992, 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author may be contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <X11/Xmu/Converters.h>

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	0
 clipX               ClipX              long            0
 clipY               ClipY              long            0
 clipWidth           ClipWidth          long            -1
 clipHeight          ClipHeight         long            -1
 colormapUse         ColormapUse        XeColormapUse   XeColormapUse_SHARED
 colormapInstall     ColormapInstall    Boolean         False
 colorQuantize       ColorQuantize      XeColorQuantize XeColorQuantize_FAST
 contentFile         ContentFile        String          NULL
 contentLength       ContentLength      long            -1
 contentOffset       ContentOffset      long            0
 contentStream       ContentStream      FILE *          NULL
 contentString       ContentString      Pointer         NULL
 cursor              Cursor             Cursor          None
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 initialOffsetX      InitialOffsetX     Dimension       0
 initialOffsetY      InitialOffsetY     Dimension       0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 maxColorss          MaxColors          int             MAXINT
 rasterWidth         RasterWidth        unsigned int    from interchange format
 rasterHeigth        RasterHeight       unsigned int    from interchange format
 visual              Visual             Visual *        NULL
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

*/


/* New fields */

#ifndef XtNvisual
#define XtNvisual "visual"
#endif
#ifndef XtCVisual
#define XtCVisual "Visual"
#endif
#define XtNclipX "clipX"
#define XtCClipX "ClipX"
#define XtNclipY "clipY"
#define XtCClipY "ClipY"
#define XtNclipWidth "clipWidth"
#define XtCClipWidth "ClipWidth"
#define XtNclipHeight "clipHeight"
#define XtCClipHeight "ClipHeight"
#define XtNcolormapUse "colormapUse"
#define XtCColormapUse "ColormapUse"
#define XtRXeColormapUse "XeColormapUse"
#define XtNcolormapInstall "colormapInstall"
#define XtCColormapInstall "ColormapInstall"
#define XtNcolorQuantize "colorQuantize"
#define XtCColorQuantize "ColorQuantize"
#define XtRXeColorQuantize "XeColorQuantize"
#define XtNoffsetX "offsetX"
#define XtCOffsetX "OffsetX"
#define XtNoffsetY "offsetY"
#define XtCOffsetY "OffsetY"
#define XtNmaxColors "maxColors"
#define XtCMaxColors "MaxColors"
#define XtNrasterWidth "rasterWidth"
#define XtCRasterWidth "RasterWidth"
#define XtNrasterHeight "rasterHeight"
#define XtCRasterHeight "RasterHeight"

typedef enum
    {
	XeColormapUse_SHARED,
	XeColormapUse_SHAREDOWN,
	XeColormapUse_OPTIONAL,
	XeColormapUse_PRIVATE
    } XeColormapUse;

typedef enum
    {
	XeColorQuantize_SLOW,	/* (from xv, based on Heckbert's Median Cut */
	XeColorQuantize_FAST,	/* (from xv, F-S dithering */
	XeColorQuantize_BEST,	/* (from xv/PBMPLUS, ppmquant) */
	XeColorQuantize_JPEG	/* IJG quantification, only for jpeg images */
    } XeColorQuantize;

/* Class record constants */

extern WidgetClass xeRasterWidgetClass;

typedef struct _XeRasterClassRec *XeRasterWidgetClass;
typedef struct _XeRasterRec      *XeRasterWidget;

#endif
