#ifndef _XewTextEd_h
#define _XewTextEd_h
/*
** Copyright 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <X11/Xmu/Converters.h>
#include <X11/Xew/Basic.h>
#include <X11/Xew/Text.h>

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 alignment           XeAlignment        XeAlignment     XeStartAligned
 allowEdit           AllowEdit          Boolean         True
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 contentFile         ContentFile        String          NULL
 contentLength       ContentLength      long            Computed from content
 contentOffset       ContentOffset      long            0
 contentStream       ContentStream      FILE *          NULL
 contentString       ContentString      Pointer         NULL
 cursor              Cursor             Cursor          None
 cursorPosition      CursorPosition     long            0
 destroyCallback     Callback		Pointer		NULL
 exportFormat        ExportFormat       XeTextExport    XeTextExport_ODIF
 firstLineOffset     Offset             int             0
 fonts               XeFonts            XeFont *        NULL
 format              Format             Boolean         False
 graphicRendition    Rendition          String          NULL
 height		     Height		Dimension	0
 indentation         Offset             Dimension       0
 initialState        Sequence           String          NULL
 itemization         Itemization        XeItemization * NULL
 kerningOffset       KerningOffset      Dimension *     NULL
 lineLayoutTable     LineLayoutTable    XeTabStop *     NULL
 lineSpacing         LineSpacing        Dimension       Computed from font
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 proportional        Proportional       Boolean         False
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

*/

/* New fields */
#define XtNallowEdit "allowEdit"
#define XtCAllowEdit "AllowEdit"
#define XtNcursorPosition "cursorPosition"
#define XtCCursorPosition "CursorPosition"

/* Class record constants */

extern WidgetClass xeTextEdWidgetClass;

typedef struct _XeTextEdClassRec *XeTextEdWidgetClass;
typedef struct _XeTextEdRec      *XeTextEdWidget;

_XFUNCPROTOBEGIN
Boolean XeTextSaveAsFile
	(
#if NeedFunctionPrototypes
	 Widget, String
#endif
	 );

String XeTextGetString
	(
#if NeedFunctionPrototypes
	 Widget, long *
#endif
	 );

String XeTextGetSubstring
	(
#if NeedFunctionPrototypes
	 Widget, long *, long, long
#endif
	 );

typedef int (*XeTextExtractFeed)
 (
#if NeedFunctionPrototypes
  char *,		/* Extracted text portion */
  int,			/* The length of the text */
  int,			/* The content TAG value */
  XtPointer		/* client_data */
#endif
 );

void XeTextExtract
	(
#if NeedFunctionPrototypes
	 Widget, long, long, XeTextExtractFeed, XtPointer
#endif
	 );

void XeTextReplace
	(
#if NeedFunctionPrototypes
	 Widget, long, long, char *, long
#endif
	 );

void XeTextGetSelectionPosition
	(
#if NeedFunctionPrototypes
	 Widget, long *, long *
#endif
	 );

void XeTextSetSelection
	(
#if NeedFunctionPrototypes
	 Widget, long, long
#endif
	 );

void XeTextUnsetSelection
	(
#if NeedFunctionPrototypes
	 Widget
#endif
	 );
_XFUNCPROTOEND
#endif
