#ifndef _XewTextEdP_h
#define _XewTextEdP_h
/*
** Copyright 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author may be contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <stdio.h>
#include <X11/Xew/BasicP.h>
#include <X11/Xew/TextP.h>
#include <X11/Xew/TextEd.h>

typedef struct _XeTextEdClass
    {
	int makes_compiler_happy;	/* not used */
    } XeTextEdClassPart;


typedef struct _XeTextEdClassRec
    {
	CoreClassPart core_class;
	XeBasicClassPart basic_class;
	XeTextClassPart text_class;
	XeTextEdClassPart texted_class;
    } XeTextEdClassRec;

typedef struct
    {
	Snip *snip;
	int offset;
    } XeTextPosition;

typedef struct
    {
	long range[2];		/* Range of the selected area */
	XRectangle rect[3];	/* Current Selected Area (for expose) */
	int nrect;		/* Number of rectanges in sel_rect (0,1,3) */
	Atom *selections;	/* Owned selections */
	int atom_count;		/* Number of  atoms in selections */
	int array_size;		/* Size of the selections array */
    } XeTextSelection;

typedef struct
    {
	/* resources */
	Boolean	allow_edit;	/* True, if editing allowed */
	long cursor_position;	/* Current position (virtual offset) */

	/* private state */

	Pixmap cursor;		/* Cursor Image Bitmap */
	short cursor_x, cursor_y; /* Cursor Position */
	short cursor_goal;	/* Horizontal target position for cursor */
	XeTextSelection s;	/* Current Selection information */
	int mult;		/* Repeater count for actions */
	Boolean display_caret;
	Time time;		/* Time of the last event */
    } XeTextEdPart;

typedef struct _XeTextEdRec
    {
	CorePart	core;
	XeBasicPart	basic;
	XeTextPart	text;
	XeTextEdPart	texted;
    } XeTextEdRec;

/* Class pointer */
extern XeTextEdClassRec xeTextEdClassRec;
#endif

